"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const browser_events_1 = __importDefault(require("./browser_events"));
const fail_if_not_loaded_1 = __importDefault(require("../../decorators/fail_if_not_loaded"));
class BrowserNavigation extends browser_events_1.default {
    back() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._page.goBack();
            yield this._afterPageLoad();
        });
    }
    forward() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._page.goForward();
            yield this._afterPageLoad();
        });
    }
    refresh() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._page.reload();
            yield this._afterPageLoad();
        });
    }
    waitForPageLoad() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._page.waitForNavigation({
                waitUntil: "domcontentloaded"
            });
            yield this._page.waitForFunction(() => {
                const w = window;
                return Boolean(w.WendigoUtils && w.WendigoQuery && w.WendigoPathFinder); // Waits until Wendigo is ready
            });
        });
    }
}
__decorate([
    fail_if_not_loaded_1.default,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], BrowserNavigation.prototype, "back", null);
__decorate([
    fail_if_not_loaded_1.default,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], BrowserNavigation.prototype, "forward", null);
__decorate([
    fail_if_not_loaded_1.default,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], BrowserNavigation.prototype, "refresh", null);
exports.default = BrowserNavigation;
