"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const wendigo_module_1 = __importDefault(require("../wendigo_module"));
const utils_1 = require("../../utils/utils");
class BrowserAuth extends wendigo_module_1.default {
    http(credentials) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.clear();
            if (credentials) {
                const token = (0, utils_1.base64)(`${credentials.user}:${credentials.password}`);
                yield this._setAuthorizationHeader(`Basic ${token}`);
            }
        });
    }
    bearer(token) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.clear();
            if (token)
                yield this._setAuthorizationHeader(`Bearer ${token}`);
        });
    }
    clear() {
        return this._setAuthorizationHeader();
    }
    _setAuthorizationHeader(txt) {
        return __awaiter(this, void 0, void 0, function* () {
            return this._browser._headerHelper.setAuthHeader(txt);
        });
    }
}
exports.default = BrowserAuth;
