import { BrowserContext, Page, Permission } from "./puppeteer_types";
import PuppeteerPage from "./puppeteer_page";
export default class PuppeteerContext {
    context: BrowserContext;
    constructor(context: BrowserContext);
    getDefaultPage(): Promise<PuppeteerPage>;
    pages(): Promise<Array<Page>>;
    getPage(index: number): Promise<PuppeteerPage | void>;
    newPage(): Promise<PuppeteerPage>;
    on(eventName: string, cb: (msg: any) => Promise<void>): void;
    off(eventName: string, cb: (msg: any) => Promise<void>): void;
    overridePermissions(url: string, permissions: Array<Permission>): Promise<void>;
}
