/// <reference types="node" />
import { ElementHandle, GeolocationOptions, PDFOptions, WaitForNavigationOptions, WebWorker, Browser, Cookie, Frame, HTTPResponse, JSHandle, Keyboard, MediaFeature, Mouse, Page, ScreenshotOptions, ScriptTagOptions, SerializableOrJSHandle, Touchscreen, ViewportOptions, SetCookie, DeleteCookie, WaitForOptions, WaitForCallbackFunction } from './puppeteer_types';
export default class PuppeteerPage {
    page: Page;
    constructor(page: Page);
    get keyboard(): Keyboard;
    get mouse(): Mouse;
    get touchscreen(): Touchscreen;
    goto(url: string): Promise<HTTPResponse | null>;
    browser(): Browser;
    frames(): Array<Frame>;
    close(): Promise<void>;
    isClosed(): boolean;
    setViewport(config?: ViewportOptions): Promise<void>;
    on(eventName: string, cb: (msg: any) => void): void;
    off(eventName: string, cb: (msg: any) => void): void;
    evaluateHandle(cb: string | ((...args: any[]) => any), ...args: Array<SerializableOrJSHandle>): Promise<JSHandle>;
    addScriptTag(options: ScriptTagOptions): Promise<void>;
    setUserAgent(userAgent: string): Promise<void>;
    setBypassCSP(value: boolean): Promise<void>;
    content(): Promise<string>;
    screenshot(args?: ScreenshotOptions): Promise<string | Buffer | void>;
    select(cssPath: string, ...values: Array<string>): Promise<Array<string>>;
    title(): Promise<string>;
    goBack(): Promise<void>;
    goForward(): Promise<void>;
    reload(): Promise<void>;
    waitForNavigation(options?: WaitForNavigationOptions): Promise<void>;
    waitForXPath(xpath: string, options?: WaitForOptions): Promise<void>;
    waitForSelector(selector: string, options?: WaitForOptions): Promise<void>;
    waitForFunction(func: WaitForCallbackFunction | string, options?: {
        timeout?: number;
        polling?: string | number;
    }, ...args: Array<SerializableOrJSHandle>): Promise<void>;
    $(selector: string): Promise<ElementHandle<Element> | null>;
    $x(selector: string): Promise<Array<ElementHandle<Element>>>;
    $$(selector: string): Promise<Array<ElementHandle<Element>>>;
    cookies(...urls: Array<string>): Promise<Array<Cookie>>;
    setCookie(...cookies: Array<SetCookie>): Promise<void>;
    deleteCookie(...cookies: Array<DeleteCookie>): Promise<void>;
    workers(): Array<WebWorker>;
    setRequestInterception(b: boolean): Promise<void>;
    pdf(options?: PDFOptions): Promise<Buffer>;
    setCache(value: boolean): Promise<void>;
    setExtraHTTPHeaders(headers: Record<string, string>): Promise<void>;
    setContent(html: string): Promise<void>;
    emulateTimezone(tz?: string): Promise<void>;
    setGeolocation(geolocation: GeolocationOptions): Promise<void>;
    emulateMediaType(mediaType: string): Promise<void>;
    emulateMediaFeatures(mediaFeatures: Array<MediaFeature>): Promise<void>;
}
